seo:
  title: >-
    Développement de GitLab Duo : comment nous utilisons nos propres
    fonctionnalités d’IA
  description: >-
    Dans le cadre de notre série d’articles de blog, nous partageons des
    exemples concrets de la façon dont nous intégrons l'IA dans notre cycle de
    développement logiciel et comment nous utilisons des métriques pour évaluer
    leur réussite.
  ogTitle: >-
    Développement de GitLab Duo : comment nous utilisons nos propres
    fonctionnalités d’IA
  ogDescription: >-
    Dans le cadre de notre série d’articles de blog, nous partageons des
    exemples concrets de la façon dont nous intégrons l'IA dans notre cycle de
    développement logiciel et comment nous utilisons des métriques pour évaluer
    leur réussite.
  noIndex: false
  ogImage: images/blog/hero-images/blog-hero-banner-1-0178-820x470-fy25.png
  ogUrl: >-
    https://about.gitlab.com/blog/developing-gitlab-duo-how-we-are-dogfooding-our-ai-features
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: >-
    https://about.gitlab.com/blog/developing-gitlab-duo-how-we-are-dogfooding-our-ai-features
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "Développement de GitLab Duo : comment nous utilisons nos propres fonctionnalités d’IA ",
            "author": [{"@type":"Person","name":"David O'Regan"}],
            "datePublished": "2024-05-20",
          }

content:
  title: >-
    Développement de GitLab Duo : comment nous utilisons nos propres
    fonctionnalités d’IA
  description: >-
    Dans le cadre de notre série d’articles de blog, nous partageons des
    exemples concrets de la façon dont nous intégrons l'IA dans notre cycle de
    développement logiciel et comment nous utilisons des métriques pour évaluer
    leur réussite.
  authors:
    - David O'Regan
  heroImage: images/blog/hero-images/blog-hero-banner-1-0178-820x470-fy25.png
  date: '2024-05-20'
  body: "***L'IA générative marque une avancée majeure dans le domaine du développement logiciel, simplifiant le processus de développement, de sécurisation et d'exploitation des logiciels. Notre nouvelle série d'articles de blog, rédigée par nos équipes produit et ingénierie, vous propose un aperçu de notre processus de création, de test et de déploiement des fonctionnalités d'IA que vous avez besoin d'intégrer dans l'ensemble de l'entreprise. Explorez les nouvelles capacités de GitLab Duo et découvrez comment elles aideront les équipes DevSecOps à livrer de meilleurs résultats aux clients.***\n\n[GitLab Duo](https://about.gitlab.com/fr-fr/gitlab-duo/), notre suite de fonctionnalités alimentées par l'IA, a transformé nos workflows d'ingénierie internes, générant des gains d'efficacité tout au long de notre processus de développement. En tant que fervents partisans du dogfooding et de la transparence, nous voulions montrer comment nos équipes tirent parti de l'IA au quotidien, y compris des fonctionnalités phares comme les suggestions de code de GitLab Duo et [GitLab Duo Chat](https://docs.gitlab.com/ee/user/gitlab_duo_chat/index.html \"Fonctionnalité GitLab Duo Chat\"), pour rationaliser les processus de développement, réduire les efforts manuels et améliorer la productivité. Découvrez dans cet article les bénéfices de GitLab Duo pour nos équipes.\n\n## Comment nos équipes utilisent GitLab Duo ? \n\nNos équipes ont intégré de nombreuses [fonctionnalités de GitLab Duo](https://about.gitlab.com/fr-fr/gitlab-duo/#features \"Fonctionnalités de GitLab Duo\"). Découvrez comment GitLab Duo les aide à mener à bien leurs projets.\n\n### Résumé et documentation\n- **Rationaliser le processus de revue de code\_:** [Gosia Ksionek](https://about.gitlab.com/company/team/#mksionek), Staff Backend Engineer, présente les avantages pratiques de l'IA dans son workflow en utilisant GitLab Duo pour rationaliser le processus de revue de code. Elle utilise efficacement GitLab Duo pour résumer les [merge requests](https://www.youtube.com/watch?v=3SIhe8dgFEc&feature=youtu.be), ce qui facilite et accélère l'examen des modifications apportées au code. En plus de résumer les merge requests, Gosia utilise également GitLab Duo pour [répondre aux questions relatives au code](https://www.youtube.com/watch?v=6n0I53XsjTc) et [expliquer les extraits de code complexes](https://www.youtube.com/watch?v=3m2YRxa1SCY). Cela améliore sa productivité et l'aide à mieux comprendre et gérer des codebases complexes. À travers ces démonstrations, Gosia souligne comment GitLab Duo peut considérablement améliorer l'efficacité et la clarté du processus de développement, ce qui en fait un outil inestimable pour les développeurs.\n\n<center>\n\nDans cette vidéo, Gosia utilise le résumé de merge requests de GitLab Duo\_:\n\n<!-- ligne vide -->\n<figure class=\"video_container\">\n  <iframe src=\"https://www.youtube.com/embed/3SIhe8dgFEc?si=Q8JG3Ix3K_THhbpv\" frameborder=\"0\" allowfullscreen=\"true\"> </iframe>\n</figure>\n<!-- ligne vide -->\n\nDans cette vidéo, Gosia utilise GitLab Duo pour répondre aux questions relatives au code\_: \n\n<!-- ligne vide -->\n<figure class=\"video_container\">\n  <iframe src=\"https://www.youtube.com/embed/6n0I53XsjTc?si=LA9VBHrgXpfJImSL\" frameborder=\"0\" allowfullscreen=\"true\"> </iframe>\n</figure>\n<!-- ligne vide -->\n\nDans cette vidéo, Gosia utilise GitLab Duo pour expliquer des extraits de code complexes\_:\n\n<!-- ligne vide -->\n<figure class=\"video_container\">\n  <iframe src=\"https://www.youtube.com/embed/3m2YRxa1SCY?si=oms3szKwZoz-4yeq\" frameborder=\"0\" allowfullscreen=\"true\"> </iframe>\n</figure>\n<!-- ligne vide -->\n\n</center>\n\n- **Condenser les fils de commentaires\_:** [Bartek Marnane](https://about.gitlab.com/company/team/#bmarnane), Vice President of Expansion Software Development, utilise GitLab Duo pour condenser de longs fils de discussion en résumés concis, en veillant à ce que tous les détails pertinents soient capturés lors de la mise à jour des descriptions des tickets.\n\n- **Créer une nouvelle documentation\_:** [Taylor McCaslin](https://about.gitlab.com/company/team/#tmccaslin), Group Manager, Product - Data Science Section, a tiré parti de GitLab Duo afin de [créer une nouvelle documentation pour GitLab Duo](https://docs.gitlab.com/ee/user/gitlab_duo/index.html \"Documentation de GitLab Duo\"). Ce qui lui a permis d'améliorer la clarté et la cohérence du contenu, tout en réduisant considérablement le temps requis pour documenter de nouvelles fonctionnalités.\n\n- **Rédiger des notes de version :** [Amanda Rueda](https://about.gitlab.com/company/team/#amandarueda), Senior Product Manager, utilise GitLab Duo pour [rédiger des résumés brefs et percutants pour les notes de version](https://gitlab.com/groups/gitlab-org/-/epics/10267), mettant en évidence les modifications et leur valeur pour les utilisateurs. En utilisant des prompts bien conçus comme ci-dessous, Amanda dynamise son workflow et s'assure que chaque note de version est claire, concise et centrée sur l'utilisateur, améliorant ainsi la communication globale et l'expérience utilisateur :\n<br><br>*« Veuillez créer un résumé en deux phrases de ce changement, qui peut être utilisé pour nos notes de version. Le ton doit être décontracté et le tutoiement doit être utilisé. Le résumé doit inclure une description du problème ou du changement apporté et être lié à la valeur que nous créons pour vous, l'utilisateur. »*\n<br><br>\n    - Voici quelques exemples de notes de version co-créées avec GitLab Duo :\n      - [Options étendues pour trier votre roadmap](https://gitlab.com/gitlab-org/gitlab/-/issues/460492)\n      - [Clarté du tableau de bord des tickets avec jalons et itérations](https://gitlab.com/gitlab-org/gitlab/-/issues/25758)\n      - [Fonctionnalités de gestion de la conception étendues aux équipes produit](https://gitlab.com/gitlab-org/gitlab/-/issues/438829)\n\n- **Optimiser la navigation sur le site de documentation :** [Suzanne Selhorn](https://about.gitlab.com/company/team/#sselhorn), Staff Technical Writer, a tiré parti de GitLab Duo pour [optimiser la navigation à gauche de la documentation](https://docs.gitlab.com/ee/user/get_started/get_started_projects.html) en fournissant un ordre de pages basé sur le workflow. Suzanne a fourni une liste de fonctionnalités à GitLab Duo, qui a généré l'ordre optimal, mettant à jour la navigation de gauche en conséquence. GitLab Duo a également rédigé la documentation [de démarrage](https://docs.gitlab.com/ee/user/get_started/get_started_planning_work.html) beaucoup plus rapidement que si Suzanne l’avait fait manuellement.\n\n### Définition des objectifs et alignement de l'équipe\n- **Rédiger et affiner des OKR\_:** [François Rosé](https://about.gitlab.com/company/team/#francoisrose), Engineering Manager, trouve l'aide de [GitLab Duo Chat](https://about.gitlab.com/blog/2024/04/18/gitlab-duo-chat-now-generally-available/) inestimable pour rédiger et affiner des OKR. En formulant des objectifs clairs et efficaces, François améliore la définition des objectifs et l'alignement de son équipe. En utilisant le chat, François s'assure que chaque OKR est précis, actionnable et aligné avec les objectifs, ce qui améliore la performance et la cohésion globales de l'équipe. Voici un exemple de prompt qu'il utilise :<br><br>\n\n   *« Voici un OKR que je pense créer\_:*\n\n    *Objectif\_: Revenir sur les rétrospectives, pour favoriser une équipe prospère*\n\n    *Résultat clé : Mesurer la satisfaction des rétrospectives de 100 % des membres de l'équipe*\n\n    *Résultat clé : Identifier 3 améliorations pour les rétrospectives asynchrones*\n\n    *Résultat clé : Mettre en œuvre 1 amélioration*\n\n    *Veuillez fournir des commentaires directs sur la manière d'améliorer la formulation de cet objectif et de ces résultats clés. »*\n<br><br>\n\n- **Rationaliser les processus de recrutement :** GitLab Duo Chat a aidé [Denys Mishunov](https://about.gitlab.com/company/team/#dmishunov), Staff Frontend Engineer, à mettre à jour le modèle d'e-mail pour les candidats aux entretiens techniques en formulant un texte clair et concis. De cette manière, l'équipe collabore pour affiner la communication afin de s'assurer que les candidats reçoivent toutes les informations nécessaires.\n\n### Réponse et configuration des incidents\n- **Résumer les incidents en production\_:** [Steve Xuereb](https://about.gitlab.com/company/team/#sxuereb), Staff Site Reliability Engineer, utilise GitLab Duo pour résumer les incidents en production et créer des revues d'incidents détaillées, rationalisant ainsi le processus de documentation.\n\n- **Créer des fichiers «\_.gitlab-ci.yml\_»\_:**  Steve utilise également la fonctionnalité Chat pour créer des fichiers de type «\_.gitlab-ci.yml\_», ce qui a considérablement accéléré son worfklow. De plus, l'[explication de code](https://docs.gitlab.com/ee/user/ai_features.html#code-explication) fournit des réponses détaillées qui sont utiles lors d'incidents, améliorant sa productivité et sa compréhension du codebase.\n\n### Génération de code et tests\n- **Développement full stack\_:** [Peter Hegman](https://about.gitlab.com/company/team/#peterhegman), Senior Frontend Engineer, utilise les [suggestions de code pour son développement JavaScript et Ruby](https://gitlab.com/gitlab-org/gitlab/-/issues/435783#note_1731321963). Les suggestions de code sont devenues un outil puissant pour les développeurs évoluant au sein d'une pile technique complète.\n\n- **Générer des scripts Python\_:** Denys a mené [une expérience en utilisant GitLab\_Duo pour une tâche non liée à GitLab](https://gitlab.com/gitlab-org/ai-powered/ai-framework/ai-experimentation). Cet exemple met en évidence la flexibilité et l'utilité de nos outils d'IA au-delà des tâches de développement de logiciels typiques.\n\n<center>\n\nRegardez comment Denys utilise GitLab Duo pour générer des scripts Python afin de récupérer des données de contenu et les stocker localement\_:\n\n<!-- ligne vide -->\n<figure class=\"video_container\">\n  <iframe src=\"https://www.youtube.com/embed/30ZTtk4K5yU?si=p5ZcFLg6dTZL5gFE\" frameborder=\"0\" allowfullscreen=\"true\"> </iframe>\n</figure>\n<!-- ligne vide -->\n\n</center>\n\n### Recherche et assistance\n- **Générer le code source de test\_:**  [Michael Friedrich](https://about.gitlab.com/company/team/#dnsmichi), Senior Developer Advocate, utilise GitLab Duo pour générer le code source de test pour les composants CI/CD. Cette approche a été partagée dans diverses conférences et présentations, notamment lors de l’événement Open Source @ Siemens ([consultez la présentation](https://go.gitlab.com/duA2Fc)). De cette manière, l'utilisation de GitLab Duo permet de s'assurer que le code est cohérent, bien documenté et aligné avec nos bonnes pratiques. Découvrez [l’exemple de Rust](https://gitlab.com/components/rust#contributing).\n\n![Exemple Rust](//images.ctfassets.net/r9o86ar0p03f/2zyZHBTrPNlGbikvP03mkx/97d32d01f88e465a1d39818dcc45d1b2/image2.png) \n\n- **Rationaliser les tâches de recherche\_:** Les membres de notre équipe se tournent régulièrement vers le chat lorsqu'ils ont des questions sur les fonctionnalités de GitLab. «\_Lorsque j'ai une question sur les fonctionnalités de GitLab, j'utilise systématiquement le chat plutôt que d'ouvrir 100\_onglets de navigateur. Ce workflow m'aide à apporter une aide efficace aux utilisateurs du forum de notre communauté. Par exemple, j'ai récemment [aidé un utilisateur dans le cadre d'un déploiement SSH](https://forum.gitlab.com/t/how-to-make-ssh-deployment-more-clear-in-gitlab/102051/4?u=dnsmichi) en utilisant cette méthode.\_», indique Michael. L'utilisation du chat permet non seulement de gagner du temps, mais aussi de fournir des informations rapides et précises, améliorant ainsi l'assistance que nous offrons à notre communauté.\n\n### Test de fonctionnalités\n- **Tester les nouvelles fonctionnalités\_:** Nos ingénieurs utilisent GitLab Duo pour tester de nouvelles fonctionnalités telles que [la prise en charge de Markdown dans les suggestions de code](https://gitlab.com/gitlab-org/gitlab/-/issues/443365). «\_Je dois tester la prise en charge de Markdown dans les suggestions de code pour rédiger des articles de blog et la documentation de GitLab dans VS Code. J'ai vu que cela avait été fusionné pour la version 17.0\_», indique l'un des membres de notre équipe. En testant ces fonctionnalités en interne, nous nous assurons qu'elles répondent à nos normes de qualité avant leur sortie.\n\n### Comprendre les codebases externes\n- **Expliquer les projets externes\_:** La fonctionnalité «\_/explain\_» de GitLab Duo est particulièrement utile pour comprendre les projets externes importés dans GitLab. Cette capacité a été mise en avant dans un récent livestream animé par Michael Friedrich et Eddie Jaoude, expert en open source. Dans cette vidéo, Michael nous fait savoir qu’il utilise la fonctionnalité « /explain » sur des projets externes pour comprendre le code source et qu’il a présenté cette idée pour en apprendre davantage sur les projets open source, les dépendances, etc. Cette fonctionnalité est inestimable pour les développeurs qui doivent rapidement comprendre les fonctionnalités et les dépendances de codebases inconnues, ce qui améliore considérablement leur efficacité et leur compréhension.\n\n<center>\nRegardez la vidéo de Michael sur la fonctionnalité « /explain » lors du livestream avec Eddie Jaoude :\n<!-- ligne vide -->\n<figure class=\"video_container\">\n  <iframe src=\"https://www.youtube.com/embed/L2Mx8hOhkEE?si=R7W3v4EDqeJCaPOw\" frameborder=\"0\" allowfullscreen=\"true\"> </iframe>\n</figure>\n<!-- ligne vide -->\n\n</center>\n\n## Quels sont les avantages de GitLab Duo ?\n\nL'intégration de GitLab Duo a eu de nombreux impacts positifs, ce qui a considérablement amélioré nos workflows d'ingénierie et de développement de produits\_:\n\n- De nombreuses tâches qui nécessitaient auparavant une intervention manuelle sont désormais automatisées, ce qui libère un temps précieux pour nos ingénieurs. Par exemple, la synthèse de longs fils de discussion et la création de code standard sont désormais plus efficaces, ce qui permet à notre équipe de se concentrer sur des problèmes plus complexes.\n- Le temps nécessaire pour documenter et résumer les tickets a diminué, ce qui permet une diffusion de l'information et une prise de décision plus rapides.\n- Avec les suggestions de code et les explications assistées par l'IA, nos équipes produisent un code de meilleure qualité avec moins d'erreurs et des processus de débogage plus rapides. L'intégration de GitLab Duo dans les revues d'incidents et l'assistance au codage a rendu les revues de code plus efficaces et plus efficientes.\n- Les tâches administratives, telles que la rédaction d'OKR et la création de notes de version, ont été rationalisées.\n\nGitLab Duo a contribué non seulement à améliorer notre efficacité, mais également à améliorer la qualité et la rapidité de nos processus de développement, illustrant ainsi le pouvoir de transformation de l'IA dans le développement de logiciels.\n\n## Et après ?\n\nNous nous engageons à intégrer davantage l'IA dans nos workflows et à améliorer continuellement les fonctionnalités de GitLab Duo en fonction des retours internes et de l'évolution des besoins. La collecte de données avec le tableau de bord d'analyse d'impact de l'IA guidera les améliorations et fera en sorte que GitLab Duo reste à la pointe des outils de développement pilotés par l'IA.\n\n![Dogfooding appliqué à GitLab Duo - tableau de bord d'analyse de l'IA](//images.ctfassets.net/r9o86ar0p03f/5vuWg6UUFT1EKNZVy4l4PS/0aa6f293495d0d488e650e4b82d02183/image1.png)\n\n> [Essayez GitLab Duo gratuitement dès aujourd'hui !](https://about.gitlab.com/fr-fr/gitlab-duo/#free-trial)\n\n## En savoir plus sur le « Développement de GitLab Duo »\n\n- [Comment nous validons et testons les modèles d'IA à grande échelle](https://about.gitlab.com/fr-fr/blog/2024/05/09/developing-gitlab-duo-how-we-validate-and-test-ai-models-at-scale/)\n- [Mesurer le ROI de l’IA avec le tableau de bord d'analyse d'impact](https://about.gitlab.com/fr-fr/blog/2024/05/15/developing-gitlab-duo-ai-impact-analytics-dashboard-measures-the-roi-of-ai/)\n- [Tester et sécuriser le code généré par l'IA](https://about.gitlab.com/fr-fr/blog/2024/05/30/how-gitlab-duo-helps-secure-and-thoroughly-test-ai-generated-code/ \"Tester et sécuriser le code généré par l'IA\")\n- [L'IA combinée à l'analyse des causes profondes pour réparer les pipelines CI/CD](https://about.gitlab.com/fr-fr/blog/2024/06/06/developing-gitlab-duo-blending-ai-and-root-cause-analysis-to-fix-ci-cd/ \"L'IA combinée à l'analyse des causes profondes pour réparer les pipelines CI/CD\")"
  category: IA/ML
  tags:
    - AI/ML
    - code review
    - features
    - DevSecOps platform
    - workflow
config:
  slug: developing-gitlab-duo-how-we-are-dogfooding-our-ai-features
  featured: true
  template: BlogPost
